#include <iostream>
#include "node.h"
using namespace std;


LinkedList::LinkedList() {
        head = NULL; // set head to NULL
}

Node * LinkedList::add_char(int x, int y, int a) {
        Node *n = new Node();
        n->x = x;
        n->y = y;
        n->ascii = a;
        n->tgxf_char = 0;
	if(a == 48 || a == 49) {
          n->tgxf_char = 1;
	  n->bit = a - 48;
        }
        n->tgxf_row = 0;
        n->next = head;

        head = n;
        return n;
}

Node * LinkedList::get_next(Node * n) {
	if (!n)
		return head;
	return n->next;
}

Node * LinkedList::del_char(Node * n) {
	if (!n)
		return NULL;
	if (!head)
		return NULL;
	Node *r = n->next;
	if (head == n) {
		head = n->next;
	} else {
		Node *p = head;
		while (p != NULL) {
			if(p->next == n) {
				p->next = n->next;
				break;
			}
			p = p->next;
		}
	}
        delete n;
        return r;
}

void LinkedList::empty_list(void) {
	while(del_char(head) != NULL);
	return;
}

int LinkedList::get_nearest_y(int y) {
	int nearest_y = -1;
	Node *n = head;
        while(n != NULL) {
	  if(n->y > y) {
	    if(nearest_y < 0) {
	      nearest_y = n->y;
            } else {
              if(nearest_y > n->y)
                nearest_y = n->y;
            }
          }
	  n = n->next;
        }
	return nearest_y;
}

int LinkedList::get_nearest_x_for_y(int x, int y, int tgxf_chars) {
	int nearest_x = -1;
	Node *n = head;
        while(n != NULL) {
          if(tgxf_chars == 0 || (tgxf_chars == 1 && n->tgxf_char == 1)) {
	    if(n->y == y) {
	      if(n->x > x) {
	        if(nearest_x < 0) {
	          nearest_x = n->x;
                } else {
                  if(nearest_x > n->x)
                    nearest_x = n->x;
                }
              }
            }
          }
	  n = n->next;
        }
	return nearest_x;
}

int LinkedList::mark_row(int y) {
	int count = 0;
	Node *n = head;
        while(n != NULL) {
	  if(n->y == y) {
	    n->tgxf_row=1;
	    count++;
	  }
	  n = n->next;
        }
	return count;
}

int LinkedList::mark_tgxf_rows(void) {
	int row_count = 0;
	int screen_row_y = -1;
	while((screen_row_y = get_nearest_y(screen_row_y)) > -1) {
	  int screen_col_x = -1;
	  int col_count = 0;
	  while((screen_col_x = get_nearest_x_for_y(screen_col_x, screen_row_y, 1)) > -1) {
	    col_count++;
	  }
	  if(col_count == 16) {
	    mark_row(screen_row_y);
	    row_count++;
          }
	  col_count = 0;
	}
	return row_count;
}

Node * LinkedList::get_next_tgxf_char(Node * n) {
	if (!n) {
		n = head;
        } else {
	  if(!n->next)
	    return NULL;
	  n = n->next;
	}
        while(n != NULL) {
	  if(n->tgxf_row == 1) {
	    return n;
	  }
	  n = n->next;
	}
	return NULL;
}

Node * LinkedList::append_tgxf_octet(int c, int o) {
	Node *n = head;
        while(n != NULL) {
	  if(n->counter == c && n->octet == o) {
	    return NULL;
          }
	  n = n->next;
        }
        n = new Node();
        n->counter = c;
        n->octet = o;
	Node *p = head;
	if(p == NULL) {
	  head = n;
	} else {
	  while (p != NULL) {
	    if(p->next == NULL) {
	      p->next = n;
	      break;
	    }
	    p = p->next;
	  }
	}
        return n;
}

int LinkedList::populate_tgxf_list(LinkedList& tgxf_list) {
        Node * chr = NULL;
	int old_y = 0;
        int x_count = 0;
        int counter = 0;
        int octet = 0;
        int total = 0;
        while((chr = get_next_tgxf_char(chr)) != NULL) {
          if(old_y != chr->y) {
            old_y = chr->y;
            x_count = 0;
          }
          x_count++;
          if(x_count <= 8) {
            counter = counter << 1;
            counter |= chr->bit;
          }
          if(x_count > 8) {
            octet = octet << 1;
            octet |= chr->bit;
          }
          if(x_count == 16) {
            tgxf_list.append_tgxf_octet(counter, octet);
            counter = 0;
            octet = 0;
	    total++;
          }
        }
	return total;
}


Node * LinkedList::pop_tgxf_octet() {
	Node *n = head;
	if(n == NULL)
	  return NULL;
	head = n->next;
	return n;
}
